/*
 ઠ ਭ.  7  1998 

     labirint.txt
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>   /*쪮  ⫠ - . delay()*/

#define ROWS 50 /* ᨬ쭮 ᫮ ப */
#define COLS 50 /* ᨬ쭮 ᫮ ⮫殢 */
#define WAY 1000 /*  ᨬ쭮   ਭ */
char Lab[ROWS][COLS];

////////////   ࢨ 㭪権  ࠡ  ࠭
void TextColor (int Col, int Bk) { textcolor (Col); textbackground (Bk); }

void Logo (void) { //⨯ ணࠬ
 clrscr();
 gotoxy (1,25);
 TextColor (BLACK,LIGHTGRAY);
 cprintf ("%79s\r","Mirror Labyrinth. "
	  "Needs DOS mode with cyrillic "
	  "symbols for normal working");
 window (1,1,80,24);
 window (3,3,78,23); TextColor (YELLOW,BLUE); clrscr();
}

void Error (int Code) { //饭  訡  襭 ࠡ
 char *Msg[]={
  "",
  "Mirror Labyrinth. Give me file name as parameter",
  "File open error",
  "Read data error",
  "Invalid labyrinth dimension",
  "Can't read matrix from '*','.','/' and '\' symbols from this file",
  "Overflow - the way is too long. Increase the value WAY in program"
 };
 cprintf ("\r\n Errorcode=%d:\r\n %s!\r\n Press ENTER...",Code,Msg[Code]);
 fflush (stdin); getch();
 window (1,1,80,25); TextColor (LIGHTGRAY,BLACK); clrscr();
 exit (Code);
}
////////////    ࢨ 㭪権  ࠡ  ࠭

////////////   㭪権 ࠡ  䠩
FILE *Open(char *Name, char *Mode) { //⨥ 䠩
 FILE *f;
 f=fopen (Name,Mode);
 if (f==NULL) Error (2);
 return f;
}

int Close (FILE *f) { //⨥ 䠩
 return (fclose (f));
}

char ReadItem (FILE *f, char *s) {
 // ⥭ ᨬ c  䠩 f  ஢મ  ਭ
 //  ᨬ s
 char *Ptr; char c;
 fread (&c,1,1,f);
 Ptr=strchr (s,c);
 if (Ptr==NULL) Error (5);
 return c;
}
////////////    㭪権 ࠡ  䠩

void WriteLab (int r,int c,int i0, int j0) {
 //⫠筠  ਭ
 int i,j; char p;
 clrscr();
 for (i=0; i<r; i++) {
  cprintf ("\r\n");
  for (j=0; j<c; j++) {
   p=Lab[i][j];
   switch (p) {
    case '*': TextColor (YELLOW,BLUE); break;
    case '/':
    case '\\': TextColor (WHITE,BLUE); break;
    case '.': TextColor (GREEN,BLUE);  break;
   }
   if ((i==i0) && (j==j0)) { TextColor (RED,BLUE); p='o'; }
   cprintf ("%c",p);
  }
 }
}

void PrintLab (FILE *w, int Rows, int Cols) {
 // ਭ  䠩
 int i,j;
 for (i=0; i<Rows; i++) {
  fprintf (w,"\n");
  for (j=0; j<Cols; j++) fprintf (w,"%c",Lab[i][j]);
 }
 fclose (w);
}

int Labyrinth (int Rows, int Cols) {
 //㭪 ࠡ  ઠ ਭ⮬
 //
 //ᯮ 譨 ᨢ Lab!
 FILE *w;
 char Yes=0,Back=0,Dir;
 int Num;
 int i,j;
 char Way[WAY][4],
  //⮫ ᨢ Way:
  //                             㤠 諨
  // ப        ⮫     ઠ (/=0,\=1)    ( ࠢ)
      In[2][2]; //ப  ⮫ 室  室
 w=Open("labirint.txt","wt");

 //饬 室  室:
 for (i=0; i<Rows; i++) {
  if ((i==0) || (i==Rows-1)) {
   for (j=1; j<Cols-1; j++) {
    if (Lab[i][j]=='.') { In[Yes][0]=i; In[Yes++][1]=j; }
    else if (Lab[i][j]!='*') Error (5);
   }
   if ( (Lab[i][0]!='*') || (Lab[i][Cols-1]!='*') )
    Error (5); //  "㣫" ਭ!
  }
  else {
   if (Lab[i][0]=='.') { In[Yes][0]=i; In[Yes++][1]=0; }
   else if (Lab[i][0]!='*') Error (5);
   if (Lab[i][Cols-1]=='.') { In[Yes][0]=i; In[Yes++][1]=Cols-1; }
   else if (Lab[i][Cols-1]!='*') Error (5);
  }
  if (Yes>2) Error (5); //  1 室  1 室, 騥   㣫
 }
 //।塞 ࠢ 室:
 if (In[0][0]==0) Dir=2;             //
 else if (In[0][0]==Cols-1) Dir=0;   //
 else if (In[0][1]==0) Dir=1;        //ࠢ
 else Dir=3;                      //
 i=In[0][0]; j=In[0][1]; //騥 न 
 Num=0; // ⥪饣 ઠ (  ᨢ Way)
 do { //砫 ᭮ 横 ࠡ  ਭ⮬!
  if (Lab[i][j]=='.') {//⪠ ᢮ -  אַ,   ࠢ
   switch (Dir) { //塞 㦭 न 
    case 0: i--; break; //
    case 1: j++; break; //ࠢ
    case 2: i++; break; //
    case 3: j--; break; //
   }
   if ( ((i==0) || (j==0) || (i==Rows-1) || (j==Cols-1)) &&
	(Lab[i][j]=='.') ) {
	//諨! - 筮 ஢,    ࠭ ਭ
    fprintf (w, "\n 襭 祭!");
    PrintLab (w,Rows,Cols);
    return 0;
   }
  }
  else if ( (Lab[i][j]=='/') || (Lab[i][j]=='\\')) {
   //諨  ઠ: ⠢    1  2
   //   ࠢ:
   if (Back) { //᫨ 㦥 諨     -
    Back=0;    //  ઠ
    Way[Num][2]=1; Lab[i][j]='\\';
    switch (Way[Num][3]) {
     //⠭ ஥ ࠢ      
     //ઠ
     case 0: Dir=3; j--; break;
     //᫨ 室 ᭨,    / 室 ࠢ, 
     //   \ 室 
     case 1: Dir=2; i++; break; //筮  ⠫ 砥
     case 2: Dir=1; j++; break;
     case 3: Dir=0; i--; break;
    }
   }
   else { //᫨   । - ⠢ ઠ   1
    Way[Num][0]=i; Way[Num][1]=j; Way[Num][2]=0; Lab[i][j]='/';
    Way[Num++][3]=Dir; // ஥ ࠢ  砩 
    if (Num>=WAY) Error (6); //誮   -  
    switch (Dir) {
     case 0: Dir=1; j++; break; //᫨ 諨 ᭨,  
     //ઠ / 㩤 ࠢ
     case 1: Dir=0; i--; break; // ⠫ 砥
     case 2: Dir=3; j--; break;
     case 3: Dir=2; i++; break;
    }
   }
  }
  else if (Lab[i][j]=='*') {
   //諨  ⥭,   ।饬 ઠ   
   if (Way[Num][2]==0) { //  稢  -   
    Num--; Back=1;
    switch (Dir) { //塞 ࠢ  ⨢
     case 0: Dir=2; i++; break;
     case 1: Dir=3; j--; break;
     case 2: Dir=0; i--; break;
     case 3: Dir=1; j++; break;
    }
   }
   else {
    //ࠢ 㦥 﫮,   ⪭  ⥭ -
    //襭 
    fprintf (w, "襭 !");
    PrintLab (w,Rows,Cols);
    return 0;
   }
  }
  WriteLab (Rows,Cols,i,j);   // 
  delay (300);		      // !
 } while (1);
}

int main (int argc, char *argv[]) {
 FILE *f;
 int Rows,Cols,i,j;

 Logo();
 if (argc>1) { //  -   ப?
  if ((argv[1][0]=='/') || (argv[1][0]=='?')) Error (1);
  //᫨ ⠬  /?  ? - 뤠 ଠ
  else f=Open(argv[1],"rt"); // ⠥,    䠩
 }
 else Error (1); //祣    ப - 뤠 ଠ

 fscanf (f,"%d",&Rows); // ࠧ ਭ -
 fscanf (f,"%d",&Cols); //᫮ ப  ⮫殢
 if ( (Rows<1) || (Rows>50) || (Cols<1) || (Cols>50)) Error (4);
  //஢, 墠    ਭ ⠪ ࠧ
 for (i=0; i<Rows; i++) { // ਭ
  fscanf (f,"\n");
  for (j=0; j<Cols; j++) fscanf (f,"%c",&Lab[i][j]);
 }
 fclose (f);

 Labyrinth (Rows,Cols);

 cprintf ("\r\n See the file labirint.txt!");
 fflush (stdin); getch();
 Error (0);
 return 0;
}
